#include "box.ch"

// CNVTMRPY.PRG
// Purpose: Convert Murphy.txt into a database (for quicker access)
//                                  
#define CR         chr(13)+chr(10)
#define MAXRECORDS 357             // Maximum number of records
#define TOP        8
#define LEFT       5
#define LENGTH     75              // Horizontal length of memo box
#define nFldLen    82              // length of each record
#define nHdrOffset 645             // Header offset - Not multiple of nFldLen
#define DONE       ""              // End of file (or error)
#define NEWLAW     "@"             // New murphy's law starts
#define BLUE       "+w/b,+w/b"  

procedure CnvtMrpy(cShowIt)
        local cLaw,cLine,cStatus
        local nLine:=0
        cLaw   :=""
        cLine  :=""
        if !FILE("MURPHY.DBF")
           DbCreate("murphy",{{"Law","M",10,0}}) // Create murphy.dbf
           DbUseArea(.t.,,"murphy")              // Open created database
           nHandle:=fopen("Murphy.txt")          // Open text file
           if nHandle==-1
              Alert("Error opening murphy.txt!")
              quit
           endif
           fseek(nHandle, nHdrOffset)   // Skip over header
           do while .t.              // Do until all lines are processed
              cLine:=freadstr(nhandle,nFldLen) // Read in a line
              if cLine==DONE         // If done we're out'a here
                 exit
              endif
              if left(cLine,1)==NEWLAW  // If new law stuff this one in memo field
                 setcolor("+gr/n")
                 @ 1,1 say nLine++
                 if !empty(cLaw)           // Don't create a record if empty
                    append blank
                    murphy->law:=CR+cLaw   // Place law in memo field
                    cLaw:=""               // Initialize for next law
                 endif
              else
                 cLine:=iif(empty(cLine),CR,cLine)
                 cLaw+="  "+alltrim(left(cLine,nFldLen-2))+CR
              endif
           enddo
        else
           DbUseArea(.t.,,"murphy")                // Open created database
        endif
        goto Random(MAXRECORDS)                    // Generate number < MaxRecords
        ShowMemo(murphy->law,LENGTH,"Press <ESC> to exit") // Display memo in box
        setcolor(BLUE)
return

procedure ShowMemo(cField,nLen,cMsg)
        local cColor,cScreen,cCursor
        local nTop,nLeft,nBottom,nRight,nLines
        nTop   :=TOP
        nLeft  :=LEFT
        nRight :=nLeft+nLen
        cColor :=setcolor()
        cCursor:=setcursor(0)
        nLines :=mlcount(murphy->law,nLen)
        nBottom:=nTop+nLines
        cScreen:=SaveScreen(nTop-1,0,nBottom+1,80)
        setcolor(BLUE)
        @ nTop-1 ,0 clear to nBottom,79
        @ nTop-1 ,0 say repl("",80)
        @ nBottom,0 say repl("",80)
        if cMsg!=NIL; @ nTop-1,nLeft+2 say "[ "+cMsg+" ]"; endif
        MemoEdit(cField,nTop,nLeft,nBottom-1,nRight,.f.)
        RestScreen(nTop-1,0,nBottom+1,80,cScreen)
        setcursor(cCursor)
        setcolor(cColor)
return

function random(nMax)
        local nRan,nDiv
        nRan :=int(Seconds()*seconds())
        do while nRan>nMax
           nDiv:=val(right(str(seconds()),2))
           nRan:=nRan/iif(nDiv==0,3,nDiv)
        enddo
return  nRan

