
// CNVTMRPY.PRG
// By: Bill Shields - Released to public domain
// Purpose: Convert Murphy.txt into a database (for quicker access)
//                                  

#define MAXRECORDS 357             // Maximum number of records
#define TOP        6               // Row to display data at
#define LEFT       5               // Left column to display data at
#define LENGTH     75              // Horizontal length of memo box

procedure MurphySays()
        DbUseArea(.t.,,"murphy")    // Open created database
        goto Random(MAXRECORDS)     // Generate number < MaxRecords
        SetColor("+w/r")
        ShowMemo(murphy->law,LENGTH,"Press <ESC> to exit") // Display memo in box
        use
return

procedure ShowMemo(cField,nLen,cMsg)
        local cColor,cScreen,cCursor
        local nTop,nLeft,nBottom,nRight,nLines
        nTop   :=TOP          ;nLeft  :=LEFT
        nRight :=nLeft+nLen   ;cColor :=setcolor()
        nLines :=mlcount(murphy->law,nLen)
        nBottom:=nTop+nLines  ;cScreen:=SaveScreen(nTop-1,0,nBottom+1,80)
        setcursor(0)
        @ nTop-1 ,0 clear to nBottom,79
        @ nTop-1 ,0 say repl("",80)
        @ nBottom,0 say repl("",80)
        if cMsg!=NIL; @ nTop-1,nLeft+2 say "[ "+cMsg+" ]"; endif
        MemoEdit(cField,nTop,nLeft,nBottom-1,nRight,.f.)
        RestScreen(nTop-1,0,nBottom+1,80,cScreen)
        setcolor(cColor)
return

// Random generator good enough for what we're using it for
function random(nMax,nRan,nDiv) // nRan,nDiv used as parms to declare them
        nRan :=int(Seconds()*seconds())
        do while nRan>nMax;nDiv:=val(right(str(seconds()),2))
           nRan:=nRan/iif(nDiv==0,3,nDiv);enddo
return nRan

